/*
 * Timer.c
 *
 *  Created on: 20221223
 *      Author: ningzb@163.com
 */

#include "ch32v30x_conf.h"

#include "Timer.h"

#include "Uart.h"

#include "FreeRTOS.h"
#include "task.h"

//жֻһж
void TIM7_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

__IO struct Timer timer;

/*
 *
 * ʱ ʱ1msն1
 * */
void InitBaseTimer6()
{
    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure={0};
    NVIC_InitTypeDef NVIC_InitStructure;

    //1
    RCC_APB1PeriphClockCmd( RCC_APB1Periph_TIM7, ENABLE );

    //2
    TIM_TimeBaseInitStructure.TIM_Period = 999;             // (999+1)*(1/1000000)=1/1000s=1ms
    TIM_TimeBaseInitStructure.TIM_Prescaler = 143;              //  144MHz/144=1000000Hz
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;

    TIM_TimeBaseInit( TIM7, &TIM_TimeBaseInitStructure);

    //3
    TIM_ClearITPendingBit(TIM7,TIM_IT_Update);
    TIM_ITConfig(TIM7,TIM_IT_Update,ENABLE ); //ʹTIM7жϣж


    //4
    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM7_IRQn;           //TIM2ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0; //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;        //Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;           //ʹͨ1ж

    NVIC_Init(&NVIC_InitStructure); //ʼNVIC


    //5
    TIM_Cmd(TIM7, ENABLE); //TIM2ʹ


}

void TIM7_IRQHandler()
{
    uint32_t ulReturn=taskENTER_CRITICAL_FROM_ISR();

    if(TIM_GetITStatus(TIM7, TIM_IT_Update) != RESET) //TIM3жǷ
    {

        if(timer.TickCnt!=0){
                timer.TickCnt--;
        }

        int i;

        for(i=0;i<3;i++)
        {
            if(UartRxdCtrl[i].DelayCnt!=0)
            {
                UartRxdCtrl[i].DelayCnt--;
                if(UartRxdCtrl[i].DelayCnt==0)
                {
                    if(UartRxdCtrl[i].RxdCnt!=0)
                    {
                        //յһ
                        UartRxdCtrl[i].RxdOk=0xaa;
                        UartRxdCtrl[i].RxdLen=UartRxdCtrl[i].RxdCnt;
                        UartRxdCtrl[i].RxdCnt=0;

                    }
                }

            }
        }


        TIM_ClearITPendingBit(TIM7,TIM_IT_Update);    //TIM3жϹλ
    }


    taskEXIT_CRITICAL_FROM_ISR(ulReturn);

}



