/*
 * Uart.c
 *
 *  Created on: 2022��12��22��
 *      Author: ningzb@163.com
 */

#include "ch32v30x_conf.h"
#include "Uart.h"

#include "FreeRTOS.h"
#include "task.h"




#define UART2_RXD_BUF_LEN 200//串口2接收缓冲区大小
#define UART4_RXD_BUF_LEN 200//串口2接收缓冲区大小
#define UART5_RXD_BUF_LEN 200//串口2接收缓冲区大小


__IO UART_RxdTypeDef UartRxdCtrl[3];//2,4,5

//__IO UART_RxdTypeDef *Uart2RxdCtrl;


uint8_t Uart2RxdBuf[UART2_RXD_BUF_LEN];
uint8_t Uart4RxdBuf[UART4_RXD_BUF_LEN];
uint8_t Uart5RxdBuf[UART5_RXD_BUF_LEN];


/*
 * 串口接收处理函数
*/
void UartRxd(__IO UART_RxdTypeDef *Rxd,uint8_t dat)
{
    if(Rxd->RxdOk==0xaa)
    {
        return;
    }

//    if(Rxd==&UartRxdCtrl[0])
//    {//UART1 RS485-1
//        LedOn(LED_RS4851_G);
//    }
//    else if(Rxd==&UartRxdCtrl[1])
//    {//UART3 RS485-2
//        LedOn(LED_RS4852_G);
//    }

    if(Rxd->RxdCnt<Rxd->RxdBufLen)
    {
        Rxd->RxdBuf[Rxd->RxdCnt]=dat;
        Rxd->RxdCnt++;
        Rxd->DelayCnt=Rxd->MaxDelayCnt;
    }
}



/*********************************************************************
 * @fn      void Uart2Init(void)
 *
 * @brief   串口2初始化
 *
 * @return none
 *
  * */
void Uart2Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure = {0};
    USART_InitTypeDef USART_InitStructure = {0};
    NVIC_InitTypeDef  NVIC_InitStructure = {0};


    __IO UART_RxdTypeDef *Uart2RxdCtrl;

    Uart2RxdCtrl=&UartRxdCtrl[0];

    Uart2RxdCtrl->RxdOk=0;//
    Uart2RxdCtrl->RxdLen=0;
    Uart2RxdCtrl->RxdBuf=Uart2RxdBuf;
    Uart2RxdCtrl->RxdBufLen=UART2_RXD_BUF_LEN;
    Uart2RxdCtrl->MaxDelayCnt=20;
    Uart2RxdCtrl->RxdCnt=0;
    Uart2RxdCtrl->DelayCnt=0;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2 , ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA , ENABLE);

    /* USART2 TX-->A.2   RX-->A.3 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOA, &GPIO_InitStructure);


    USART_InitStructure.USART_BaudRate = 9600;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;

    USART_Init(USART2, &USART_InitStructure);
    USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);


    NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);


    USART_Cmd(USART2, ENABLE);

}

void Uart2SendRaw(uint8_t *buf,uint32_t len){

    while(len>0)
    {
        USART_SendData(USART2, *buf);
        while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET) /* waiting for sending finish */
        {
        }

        len--;
        buf++;
    }
}


/*********************************************************************
 * @fn      USART2_IRQHandler
 *
 * @brief   This function handles USART2 global interrupt request.
 *
 * @return  none
 */
void USART2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void USART2_IRQHandler(void)
{

    uint32_t ulReturn=taskENTER_CRITICAL_FROM_ISR();


    if(USART_GetITStatus(USART2, USART_IT_RXNE) != RESET)
    {
        uint8_t dat = USART_ReceiveData(USART2);
//        UartRxd(Uart2RxdCtrl,dat);
        UartRxd(&UartRxdCtrl[0],dat);

//        if(RxCnt1 == TxSize2)
//        {
//            USART_ITConfig(USART2, USART_IT_RXNE, DISABLE);
//            Rxfinish1 = 1;
//        }

    }
    taskEXIT_CRITICAL_FROM_ISR(ulReturn);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*********************************************************************
 * @fn      void Uart4Init(void)
 *
 * @brief   串口4初始化
 *
 * @return none
 *
  * */
void Uart4Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure = {0};
    USART_InitTypeDef USART_InitStructure = {0};
    NVIC_InitTypeDef  NVIC_InitStructure = {0};


    __IO UART_RxdTypeDef *Uart4RxdCtrl;

    Uart4RxdCtrl=&UartRxdCtrl[1];

    Uart4RxdCtrl->RxdOk=0;//
    Uart4RxdCtrl->RxdLen=0;
    Uart4RxdCtrl->RxdBuf=Uart4RxdBuf;
    Uart4RxdCtrl->RxdBufLen=UART4_RXD_BUF_LEN;
    Uart4RxdCtrl->MaxDelayCnt=20;
    Uart4RxdCtrl->RxdCnt=0;
    Uart4RxdCtrl->DelayCnt=0;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART4 , ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC , ENABLE);

    /* UART4 TX-->C.10   RX-->C.11 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOC, &GPIO_InitStructure);


    USART_InitStructure.USART_BaudRate = 9600;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;

    USART_Init(UART4, &USART_InitStructure);
    USART_ITConfig(UART4, USART_IT_RXNE, ENABLE);


    NVIC_InitStructure.NVIC_IRQChannel = UART4_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);


    USART_Cmd(UART4, ENABLE);

}

void Uart4SendRaw(uint8_t *buf,uint32_t len){

    while(len>0)
    {
        USART_SendData(UART4, *buf);
        while(USART_GetFlagStatus(UART4, USART_FLAG_TXE) == RESET) /* waiting for sending finish */
        {
        }

        len--;
        buf++;
    }


}


/*********************************************************************
 * @fn      UART4_IRQHandler
 *
 * @brief   This function handles USART2 global interrupt request.
 *
 * @return  none
 */
void UART4_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void UART4_IRQHandler(void)
{
    uint32_t ulReturn=taskENTER_CRITICAL_FROM_ISR();

    if(USART_GetITStatus(UART4, USART_IT_RXNE) != RESET)
    {
        uint8_t dat = USART_ReceiveData(UART4);
//        UartRxd(Uart4RxdCtrl,dat);
        UartRxd(&UartRxdCtrl[1],dat);

//        if(RxCnt1 == TxSize2)
//        {
//            USART_ITConfig(USART2, USART_IT_RXNE, DISABLE);
//            Rxfinish1 = 1;
//        }

    }

    taskEXIT_CRITICAL_FROM_ISR(ulReturn);
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*********************************************************************
 * @fn      void Uart4Init(void)
 *
 * @brief   串口4初始化
 *
 * @return none
 *
  * */
void Uart5Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure = {0};
    USART_InitTypeDef USART_InitStructure = {0};
    NVIC_InitTypeDef  NVIC_InitStructure = {0};


    __IO UART_RxdTypeDef *Uart5RxdCtrl;

    Uart5RxdCtrl=&UartRxdCtrl[2];

    Uart5RxdCtrl->RxdOk=0;//
    Uart5RxdCtrl->RxdLen=0;
    Uart5RxdCtrl->RxdBuf=Uart4RxdBuf;
    Uart5RxdCtrl->RxdBufLen=UART4_RXD_BUF_LEN;
    Uart5RxdCtrl->MaxDelayCnt=20;
    Uart5RxdCtrl->RxdCnt=0;
    Uart5RxdCtrl->DelayCnt=0;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART5 , ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC|RCC_APB2Periph_GPIOD , ENABLE);

    /* UART5 TX-->C.12   RX-->D.2 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOD, &GPIO_InitStructure);


    USART_InitStructure.USART_BaudRate = 9600;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;

    USART_Init(UART5, &USART_InitStructure);
    USART_ITConfig(UART5, USART_IT_RXNE, ENABLE);


    NVIC_InitStructure.NVIC_IRQChannel = UART4_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);


    USART_Cmd(UART5, ENABLE);

}

void Uart5SendRaw(uint8_t *buf,uint32_t len){

    while(len>0)
    {
        USART_SendData(UART5, *buf);
        while(USART_GetFlagStatus(UART5, USART_FLAG_TXE) == RESET) /* waiting for sending finish */
        {
        }

        len--;
        buf++;
    }
}


/*********************************************************************
 * @fn      UART4_IRQHandler
 *
 * @brief   This function handles USART2 global interrupt request.
 *
 * @return  none
 */
void UART5_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void UART5_IRQHandler(void)
{
    uint32_t ulReturn=taskENTER_CRITICAL_FROM_ISR();

    if(USART_GetITStatus(UART5, USART_IT_RXNE) != RESET)
    {
        uint8_t dat = USART_ReceiveData(UART5);
//        UartRxd(Uart4RxdCtrl,dat);
        UartRxd(&UartRxdCtrl[2],dat);

//        if(RxCnt1 == TxSize2)
//        {
//            USART_ITConfig(USART2, USART_IT_RXNE, DISABLE);
//            Rxfinish1 = 1;
//        }

    }

    taskEXIT_CRITICAL_FROM_ISR(ulReturn);
}
