/*
 * Uart.h
 *
 *  Created on: 2022年12月22日
 *      Author: ningzb@163.com
 */

#ifndef USER_UART_H_
#define USER_UART_H_



//接收处理控制结构体
typedef struct
{
    unsigned char   RxdOk;      //完整接收易爆数据的标志，0xaa:接收数据有效，其他：未收到数据
    unsigned int    RxdLen;     //接收到完整的数据长度
    unsigned char   *RxdBuf;    //换成去地址
    unsigned int    RxdBufLen;  //换成去长度
    unsigned int    MaxDelayCnt;//字节间最大ticks数量

    unsigned int    RxdCnt;
    unsigned int    DelayCnt;


    uint8_t RxdDat;//中断中读取到的最新一个数据

    unsigned char (*SendRaw)(uint8_t *buf,uint len);

}UART_RxdTypeDef;

extern __IO UART_RxdTypeDef UartRxdCtrl[3];
//extern __IO UART_RxdTypeDef *Uart2RxdCtrl;



extern void Uart2Init(void);
extern void Uart2SendRaw(uint8_t *buf,uint32_t len);

extern void Uart4Init(void);
extern void Uart4SendRaw(uint8_t *buf,uint32_t len);

extern void Uart5Init(void);
extern void Uart5SendRaw(uint8_t *buf,uint32_t len);




#endif /* USER_UART_H_ */
